<html>
<head>
  <link rel="stylesheet" href="https://unpkg.com/leaflet@1.5.1/dist/leaflet.css"/>
  <!-- Make sure you put this AFTER Leaflet's CSS -->
  <script src="https://unpkg.com/leaflet@1.5.1/dist/leaflet.js"></script>
  <script src="https://unpkg.com/esri-leaflet@2.2.4"></script>
  <script src="js/leaflet.ajax.min.js"></script>
  <!--plugin to take screenshots of map-->
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
  <script src="geojson/Roads.geojson.js"></script>
  <script src="geojson/OTXzones.geojson.js"></script>
  <script src="geojson/Counties.geojson.js"></script>
  <script src="geojson/States.geojson.js"></script>
  <script src="js/bundle.js"></script>
  <style>

  #mapid {
  width: 100%;
  height: 100%; 
  }
  

* {
  font-family: Arial, "Helvetica Neue", Helvetica, sans-serif;
}
#lastupdated{
  font-size: 0.7em;
  margin: 0;
}
.popup {
  font-size: 16px;
  padding: 0;
}
.popuptitle {
  margin:0;
  text-align: center;
}
.camera {
  width:500px;
}

.legend {
    color: #ffffff;
    width: 150px;
}
.info {
    padding: 6px 8px;
    background: rgba(0,0,0,0.4);
    box-shadow: 0 0 15px rgba(0,0,0,0.2);
    border-radius: 5px;
    font-size: 20px;
    line-height: 40px;
    font-style: normal;
    font-variant: normal;
    font-weight: 500;
    //line-height: 36px;
}
.legendi {
    width: 36px;
    height: 36px;
    float: left;
    margin-right: 8px;
}
.title {
    margin: 0;
}

  </style>

</head>
<body>

   

<div id="mapid">






<script>
metadata=[]
latlon=[47.7, -118.3]
mapcircle=[]
circleradius=11
circleradius_hover=14
//colors for circles
rgb= [
[46 ,188,122,0.7,1],
[255,255,0  ,0.7,1],
[255,0  ,0  ,0.7,1],
[153,0  ,255,0.7,1],
]
thresholds=[50,85]



//Keep preferCanvas as True otherwise images will come out blury
mymap = L.map("mapid", {attributionControl: false, zoomControl:false, preferCanvas:true}).setView(latlon, 8);

//L.esri.basemapLayer("DarkGray").addTo(mymap);
L.esri.basemapLayer("Imagery").addTo(mymap);
//L.esri.basemapLayer("NationalGeographic").addTo(mymap);

//mymap.doubleClickZoom.disable(); 
//mymap.dragging.disable();
//mymap.scrollWheelZoom.disable()

/* 
  Bug with lines in map: https://github.com/Leaflet/Leaflet/issues/6101
 * Workaround for 1px lines appearing in some browsers due to fractional transforms
 * and resulting anti-aliasing.
 * https://github.com/Leaflet/Leaflet/issues/3575
 */
mymap.on('zoomend drag', function() {
  fixmaplines()
})
fixmaplines()
function fixmaplines(){
  console.log("YES")
  $('#mapid > div.leaflet-pane.leaflet-map-pane > div.leaflet-pane.leaflet-tile-pane > div > div > img').each(function() {
      if (String($( this ).css("width")).includes('.5') === false) {
      //var imgW = String($( this ).css("width")).split( "px" ).join( ".5" )
      //var imgH = String($( this ).css("height")).split( "px" ).join( ".5" )
      var imgW = Math.round(Number($( this ).css("width").split( "px" )[0]))+1.5
      var imgH = Math.round(Number($( this ).css("height").split( "px" )[0]))+1.5
      $( this ).css("width", imgW);
      $( this ).css("height", imgH);
      }
  })
}



var geojsonLayer2 = L.geoJson(roads, {
    interactive: false,
    weight: 2.0,
    color: 'rgb(255,0,0)',
    opacity: 0.5,
});
geojsonLayer2.addTo(mymap);

var geojsonLayer3 = L.geoJson(Counties, {
    interactive: false,
    weight: 1.0,
    color: 'rgb(0,0,0)',
    fillOpacity: 0.0,
    opacity: 0.9,
});
geojsonLayer3.addTo(mymap);

var geojsonLayer4 = L.geoJson(States, {
    interactive: false,
    weight: 4.0,
    color: 'rgb(0,0,0)',
    fillOpacity: 0.0,
    opacity: 0.9,
});
geojsonLayer4.addTo(mymap);

var popup = L.popup();


plot()
setInterval(function() {
  plot()
    // your code goes here...
}, 60 * 1000); // 60 * 1000 milsec




/* Good way to create custom control */
L.LegendControl = L.Control.extend({
	onAdd: function (mymap) {

		var div = L.DomUtil.create('div', 'info legend');
    div.innerHTML = '<p class="title">Fog Probability</p>'
    div.innerHTML += '<i class="legendi" style="background:rgba('+rgb[0][0]+','+rgb[0][1]+','+rgb[0][2]+','+rgb[0][4]+')"></i> ' + ("Unlikely<br>");
    div.innerHTML += '<i class="legendi" style="background:rgba('+rgb[1][0]+','+rgb[1][1]+','+rgb[1][2]+','+rgb[1][4]+')"></i> ' + ("Possible<br>");
    div.innerHTML += '<i class="legendi" style="background:rgba('+rgb[2][0]+','+rgb[2][1]+','+rgb[2][2]+','+rgb[2][4]+')"></i> ' + ("Likely<br>");
    div.innerHTML += '<p id="lastupdated"></p>'
    //div.innerHTML += '<i class="legendi" style="background:rgba('+rgb[3][0]+','+rgb[3][1]+','+rgb[3][2]+','+rgb[3][4]+')"></i> ' + ("Major<br>");
    //div.innerHTML += '<i class="legendi" style="background:rgba('+rgb[4][0]+','+rgb[4][1]+','+rgb[4][2]+','+rgb[4][4]+')"></i> ' + ("Extreme<br>");
		return div;
	}
});

L.legendControl = function(options) {
	return new L.LegendControl(options);
};

// Here we are creating control to show it on the map;
L.legendControl({position: 'bottomleft'}).addTo(mymap);


var data_points = {
    "type": "FeatureCollection",
    "name": "test-points-short-named",
    "crs": { "type": "name", "properties": { "name": "urn:ogc:def:crs:OGC:1.3:CRS84" } },
    "features": [
    { "type": "Feature", "properties": { "name": "Spokane" }, "geometry": { "type": "Point", "coordinates": [ -117.42, 47.67 ] } },
    { "type": "Feature", "properties": { "name": "Kellogg" }, "geometry": { "type": "Point", "coordinates": [ -116.14, 47.54 ] } },
    { "type": "Feature", "properties": { "name": "Bonners Ferry" }, "geometry": { "type": "Point", "coordinates": [ -116.31, 48.69 ] } },
    { "type": "Feature", "properties": { "name": "Sandpoint" }, "geometry": { "type": "Point", "coordinates": [ -116.55, 48.28  ] } },
    { "type": "Feature", "properties": { "name": "Coeur d'Alene" }, "geometry": { "type": "Point", "coordinates": [ -116.79, 47.7  ] } },
    { "type": "Feature", "properties": { "name": "Pullman" }, "geometry": { "type": "Point", "coordinates": [ -117.16, 46.74 ] } },
    { "type": "Feature", "properties": { "name": "Lewiston" }, "geometry": { "type": "Point", "coordinates": [ -116.99, 46.39 ] } },
    { "type": "Feature", "properties": { "name": "Grangeville" }, "geometry": { "type": "Point", "coordinates": [ -116.11, 45.93 ] } },
    { "type": "Feature", "properties": { "name": "Walla Walla" }, "geometry": { "type": "Point", "coordinates": [ -118.34, 46.07  ] } },
    { "type": "Feature", "properties": { "name": "Pasco" }, "geometry": { "type": "Point", "coordinates": [ -119.13, 46.25  ] } },
    { "type": "Feature", "properties": { "name": "Yakima" }, "geometry": { "type": "Point", "coordinates": [ -120.54, 46.60 ] } },
    { "type": "Feature", "properties": { "name": "Ellensburg" }, "geometry": { "type": "Point", "coordinates": [ -120.55,47.0 ] } },
    { "type": "Feature", "properties": { "name": "Wenatchee" }, "geometry": { "type": "Point", "coordinates": [ -120.32, 47.43  ] } },
    { "type": "Feature", "properties": { "name": "Plain" }, "geometry": { "type": "Point", "coordinates": [ -120.65, 47.76  ] } },
    { "type": "Feature", "properties": { "name": "Chelan" }, "geometry": { "type": "Point", "coordinates": [ -120.09, 47.85  ] } },
    { "type": "Feature", "properties": { "name": "Winthrop" }, "geometry": { "type": "Point", "coordinates": [ -120.18, 48.47  ] } },
    { "type": "Feature", "properties": { "name": "Omak" }, "geometry": { "type": "Point", "coordinates": [ -119.51, 48.41  ] } },
    { "type": "Feature", "properties": { "name": "Wilbur" }, "geometry": { "type": "Point", "coordinates": [ -118.7, 47.75 ] } },
    { "type": "Feature", "properties": { "name": "Moses Lake" }, "geometry": { "type": "Point", "coordinates": [ -119.28, 47.12 ] } },
    { "type": "Feature", "properties": { "name": "Ritzville" }, "geometry": { "type": "Point", "coordinates": [ -118.38, 47.12 ] } },
    { "type": "Feature", "properties": { "name": "Republic" }, "geometry": { "type": "Point", "coordinates": [ -118.73, 48.65 ] } },
    { "type": "Feature", "properties": { "name": "Colville" }, "geometry": { "type": "Point", "coordinates": [ -117.90, 48.54 ] } },
    ]};

var pointLayer = L.geoJSON(null, {
  pointToLayer: function(feature,latlng){
    label = String(feature.properties.name) // Must convert to string, .bindTooltip can't use straight 'feature.properties.attribute'
    return new L.CircleMarker(latlng, {
      radius: 5,
      color: 'black',
      fillColor: 'red',
      fill: true,
      fillOpacity: 0.8,
      weight: 2,
    }).bindTooltip(label, {permanent: true, 
   	direction: "center",
   	className: "my-labels"}).openTooltip();
    }
  });
//pointLayer.addData(data_points);
//mymap.addLayer(pointLayer);


  function plot(){
    getdata('static/webcams.json',function(json){
      metadata=json
      for ( var i=0; i<metadata.length; i++ ){
        fullname=metadata[i]['filename']
        name = fullname.replace(/^.*[\\\/]/, '')
        metadata[i]['pathshort']=name
      }
      plotNNresults()
      plottime()
    })
  }

  function getcolor(value){
    index=0
    for ( var i in thresholds ){
      if ( value*100 > thresholds[i] ){
        index=Number(i)+1
      }
    }
    color='rgb('+rgb[index][0]+','+rgb[index][1]+','+rgb[index][2]+')'
    return color
  }
  function plottime(){
    getdata('py/outdir/images/time.json',function(time){
      date1=new Date(time)
      var date2=new Date()
      var diffhours = Math.abs(date1 - date2) / 36e5
      document.getElementById("lastupdated").innerHTML=formatDate(date1)
      if ( diffhours > 1 ){
        //console.log("Warning: Turn back on alert")
        alert("Neural Network results are "+Math.round(diffhours*10)/10+" hours old.")
      }
    })
  }
  function formatDate(date) {
  //Format name=dly->Aug 8th, 2020; name=mtd->Aug, 2020; name=std->2020
  var d = new Date(date),
      month = '' + (d.getMonth()),
      day = '' + d.getDate(),
      year = d.getFullYear();
      var hours = d.getHours();
      var minutes = d.getMinutes();
      var ampm = hours >= 12 ? 'pm' : 'am';
      hours = hours % 12;
      hours = hours ? hours : 12; // the hour '0' should be '12'
      minutes = minutes < 10 ? '0'+minutes : minutes;

  var monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun","Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
  return monthNames[month]+" "+ordinal_suffix_of(day)+", "+hours + ':' + minutes + ' ' + ampm;
  }
  function ordinal_suffix_of(i) {
    var j = i % 10,
        k = i % 100;
    if (j == 1 && k != 11) {
        return i + "st";
    }
    if (j == 2 && k != 12) {
        return i + "nd";
    }
    if (j == 3 && k != 13) {
        return i + "rd";
    }
    return i + "th";
  }
  function plotNNresults(){
    getdata('py/outdir/images/NNresults.json',function(json){

      //First remove any circles on the map
      for ( var i in mapcircle ){
        mymap.removeLayer(mapcircle[i])
      }

      //Sort json from smallest to largest fog probability
      json.sort(function(a, b) {return a.fog - b.fog;});

      for ( var i in json ){
        var filepath=json[i]['file']
        file=filepath.replace(/^.*[\\\/]/, '') //take of leading folder /this/is/file.txt -> file.txt
        //file=file.split(/_(.+)/)[1]        //split by first underscore  105_cam1.jpg  -> cam1.jpb
        var fog=+json[i]['fog']
        var obj=metadata.find(x => x.pathshort === file)
        var name=obj['Name']
        var lat=obj['Y']
        var lon=obj['X']
        var color=getcolor(fog)
        if ( obj && lat && lon ){
          var cir=L.circleMarker([lat,lon],{
            color: 'rgb(0,0,0)',
            fillColor: color,
            weight: 1,
            opacity: 1,
            fillOpacity: 1,
            name: name,
            lat: lat,
            lon: lon,
            fog: fog,
            imgpath: 'py/outdir/'+filepath,
            //radius: 5000,
            radius: circleradius,
          }).addTo(mymap)
          mapcircle.push(cir)
          //var 


          cir.bindPopup(makediv,{autoPan: false,maxWidth: "auto"}) //autoPan prevents the map from moving when the popup appears
          cir.on('mouseover',mapmouseover)
          cir.on('mouseout',mapmouseout);
          //cir.on('click',mapmouseclick); 
        
        }
      }
    })
  }
  function makediv(e){
    //by making the div into a function, we don't preload all the cameras
    //the div is made when requested
    var randomnum=new Date().getTime()
    var imgpath=e.options.imgpath+'?random='+randomnum
    var fog=e.options.fog
    var div = L.DomUtil.create('div', 'popup');
    div.innerHTML =  '<p class="popuptitle">'+e.options.name+'<br><b>Fog Probability: '+Math.round(fog*100)+'%</b></p>'
    div.innerHTML += '<img class="camera" src="'+encodeURI(imgpath)+'">';
    return div
  }
  function mapmouseover(e){
    var city=e.target.options.city
    e.target.setStyle({
    fillOpacity: 0.4,
    radius: circleradius_hover,
    })
    e.target.openPopup()
  }
  function mapmouseout(e){
    var city=e.target.options.city
    e.target.setStyle({
    fillOpacity: 1.0,
    radius: circleradius,
    })
    e.target.closePopup()
  }

  function getdata(name,callback) {
    var randomnum=new Date().getTime() + '_' + Math.random();
    $.ajax({
        type: 'GET',
        url:  name+'?random='+randomnum,
        success: function(result){
            callback(result)
        },
        error: function(){
            console.log("Error getting data")
        }
    });
  }



</script>
</body>
</html>
